#!/usr/bin/env ruby

#
# This script configures the process environment and then
# loads a ruby script from either the base directory or
# the per-user framework directory.
#

require "Win32API"

def wgetenv(var)
	f = Win32API.new("kernel32", "GetEnvironmentVariable", ["P", "P", "I"], "I")
	buff = "\x00" * 65536
	sz = f.call(var, buff, buff.length)
	buff[0,sz]
end

def wsetenv(var,val)
	f = Win32API.new("kernel32", "SetEnvironmentVariable", ["P", "P"], "I")
	f.call(var, val + "\x00")
end


def walert(title, message)
	f = Win32API.new('user32','MessageBox',['L', 'P', 'P', 'L'],'I') 
	f.call(0, message, title, 0)
end

base = File.join(File.expand_path(File.dirname(__FILE__)), "..")
base.gsub!("/", "\\")


wsetenv("PATH", 
	"#{base}\\bin;#{base}\\tools;#{base}\\GTK\\bin;#{base}\\GTK\\lib;" +
	wgetenv("PATH")
)


Dir.chdir(base)

loc = ARGV.shift() || "framework"
app = ARGV.shift() || "msfgui"

pth = "msf32"

if(loc == "framework-dev")
	pth = "msf3-dev"
end

src = File.join(base, "#{pth}.tar").gsub("/", "\\")

# Create a private copy of the framework for each user
dest = nil

dests = %w{LOCALAPPDATA APPDATA USERPROFILE HOME}

dests.each do |tdest|
	path = wgetenv(tdest)
	if(File.directory?(path))
		dest = path
	end
	break if dest
end

if (not dest)
	walert("Metasploit Framework", "Unable to locate a local directory path for the per-user copy of Metasploit")
	exit(0)
end

frame = File.join(dest, "#{pth}")

if(not File.directory?(frame))
	Dir.chdir(dest)
	system("cmd.exe /c tar -xvf \"#{src}\"")
end

path = ""
case loc
when "framework"
	path = frame
when "framework-dev"
	path = frame

	if(not File.exists?(File.join(path, app)))
		walert("Metasploit Framework (Development)", "Please perform an Online Update before using the development tree")
		exit(0)
	end

when "base"
	path = base
when "base-dev"
	path = File.join(base, "dev")
else
	path = loc
end

load(File.join(path, app))
